#include <hmg.ch>

PROCEDURE MAIN // for test, usually edit_AMENU

   PUBLIC New := .F. , _qry_exp := ""

   set navigation extended  // for test  

   open_dbf()
   open_ntx()  
   
   Use_amenu()    // in use_dbf.prg 

   DEFINE WINDOW Win_1 ;
      AT 10,10 ;
      WIDTH 800 ;
      HEIGHT 700 ;
      TITLE "Table AMENU" ;
      MAIN  // for test, usually MODAL

      ON KEY ESCAPE ACTION Win_1.Release

      DEFINE STATUSBAR FONT "Arial" SIZE 12
         STATUSITEM "Table AMENU"
         KEYBOARD
         DATE
         CLOCK
      END STATUSBAR

      DEFINE TOOLBAR ToolBar_1 BUTTONSIZE 60,40 IMAGESIZE 32,32 FLAT BORDER

      BUTTON FIRST_1017 ;
         CAPTION "First" ;
         PICTURE "go_first" ;
         ACTION( dbGotop(), Win_1.Browse_1.Value := RecNo() )

      BUTTON PREV_1017 ;
         CAPTION "Prev" ;
         PICTURE "go_prev" ;
         ACTION( dbSkip( -1 ), Win_1.Browse_1.Value := RecNo() )

      BUTTON NEXT_1017 ;
         CAPTION "Next" ;
         PICTURE "go_next" ;
         ACTION( dbSkip(), if ( Eof(), dbGobottom(), Nil ), Win_1.Browse_1.Value := RecNo() )

      BUTTON LAST_1017 ;
         CAPTION "Last" ;
         PICTURE "go_last" ;
         ACTION( dbGoBottom(), Win_1.Browse_1.Value := RecNo() )   SEPARATOR 

      BUTTON FIND_1017 ;
         CAPTION "Find" ;
         PICTURE "edit_find" ;
         ACTION Find_1017()

      BUTTON NEW_1017 ;
         CAPTION "New" ;
         PICTURE "edit_new" ;
         ACTION ( New := .T., NewRecord_1017() )

      BUTTON EDIT_1017 ;
         CAPTION "Edit" ;
         PICTURE "edit_edit" ;
         ACTION If ( RecordStatus_1017(), EnableField_1017(), Nil )

      BUTTON DELETE_1017 ;
         CAPTION "Delete" ;
         PICTURE "edit_delete" ;
         ACTION ( RecordStatus_1017(), DeleteRecord_1017(), Nil )

      BUTTON PRINT_1017 ;
         CAPTION "Print" ;
         PICTURE "edit_print" ;
         ACTION PrintData_1017()

      BUTTON EXIT_1017 ;
         CAPTION "Exit" ;
         PICTURE "edit_close" ;
         ACTION Win_1.Release

      END TOOLBAR

      PaintDisplay_1017()

      @ 90,10 BROWSE Browse_1 ;
         OF Win_1 ;
         WIDTH 750 ;
         HEIGHT 250 ;
         FONT "Arial" ; 
         SIZE 11 ;
         HEADERS { "LEV1","LEV2","Item","Icon","Button","Program" } ;
         WIDTHS { 70,70,200,100,60,300 } ;
         WORKAREA AMENU ;
         FIELDS { "LEVEL1","LEVEL2","ITEM","M_ICON","M_BUTTON","M_PROGRAM" } ;
         ON CHANGE LoadData_1017() ;
         ON HEADCLICK { {||head1_1017()}, {||head2_1017()} } ;
         ON DBLCLICK ( EnableField_1017(), If ( ! RecordStatus_1017(), DisableField_1017(), Nil ) ) ;
         JUSTIFY { BROWSE_JTFY_RIGHT, BROWSE_JTFY_RIGHT, , , , , , } 

      @ 580, 50 BUTTON SAVE_1017 ;
         CAPTION "Save" ;
         PICTURE "ok" RIGHT ;
         ACTION SaveRecord_1017() ;
         WIDTH 100 ;
         HEIGHT 40 

      @ 580,150 BUTTON CANCEL_1017 ;
         CAPTION "Cancel" ;
         PICTURE "cancel" RIGHT ;
         ACTION CancelEdit_1017() ;
         WIDTH 100 ;
         HEIGHT 40 

      @ 580,300 BUTTON QUERY_1017 ;
         CAPTION "Query" ;
         PICTURE "edit_find" RIGHT ;
         ACTION QueryRecord_1017() ;
         WIDTH 100 ;
         HEIGHT 40 

        @ 500,650 BUTTON OpenFileName_1017 ;
         CAPTION " Open " ;
         ACTION OpenFileName_1017() ;
         WIDTH 100 ;
         HEIGHT 35
         
      @ 580,650 BUTTON CREATE_1017 ;
         CAPTION " Generate " ;
         ACTION main_menu() ;
         WIDTH 100 ;
         HEIGHT 40
         
   END WINDOW

   DisableField_1017()

   Win_1.Browse_1.SetFocus
   Win_1.Browse_1.Value := AMENU->(RecNo())

   ACTIVATE WINDOW Win_1

RETURN
*:---------------------------------------------*
PROCEDURE DisableField_1017

   Win_1.Browse_1.Enabled      := .T.

   Win_1.mLEVEL1.Enabled       := .F.
   Win_1.mLEVEL2.Enabled       := .F.
   Win_1.mITEM.Enabled         := .F.
   Win_1.mM_ICON.Enabled       := .F.
   Win_1.mM_BUTTON.Enabled     := .F.
   Win_1.mM_PROGRAM.Enabled    := .F.

   Win_1.Save_1017.Enabled     := .F.
   Win_1.Cancel_1017.Enabled   := .F.
   Win_1.Query_1017.Enabled    := .F.
   Win_1.Toolbar_1.Enabled     := .T.
   Win_1.Browse_1.SetFocus

RETURN
*:---------------------------------------------*
PROCEDURE EnableField_1017

   Win_1.Browse_1.Enabled      := .F.

   Win_1.mLEVEL1.Enabled       := .T.
   Win_1.mLEVEL2.Enabled       := .T.
   Win_1.mITEM.Enabled         := .T.
   Win_1.mM_ICON.Enabled       := .T.
   Win_1.mM_BUTTON.Enabled     := .T.
   Win_1.mM_PROGRAM.Enabled    := .T.

   Win_1.Save_1017.Enabled     := .T.
   Win_1.Cancel_1017.Enabled   := .T.
   Win_1.Query_1017.Enabled    := .F.
   Win_1.Toolbar_1.Enabled     := .F.
   Win_1.mLEVEL2.SetFocus

RETURN
*:---------------------------------------------*
FUNCTION RecordStatus_1017()

   Local RetVal

   AMENU->( dbGoTo ( Win_1.Browse_1.Value ) )

   IF AMENU->(RLock())
      RetVal := .T.
   ELSE
      MsgExclamation ("Record LOCKED, try again later")
      RetVal := .F.
   ENDIF

RETURN RetVal
*:---------------------------------------------*
PROCEDURE LoadData_1017

   AMENU->( dbGoTo ( Win_1.Browse_1.Value ) )

   Win_1.mLEVEL1.Value       := AMENU->LEVEL1    
   Win_1.mLEVEL2.Value       := AMENU->LEVEL2    
   Win_1.mITEM.Value         := AMENU->ITEM      
   Win_1.mM_ICON.Value       := AMENU->M_ICON    
   Win_1.mM_BUTTON.Value     := AMENU->M_BUTTON  
   Win_1.mM_PROGRAM.Value    := AMENU->M_PROGRAM 

RETURN
*:---------------------------------------------*
PROCEDURE CancelEdit_1017

   DisableField_1017()
   LoadData_1017()
   UNLOCK
   New := .F.

RETURN
*:---------------------------------------------*
PROCEDURE SaveRecord_1017

   Local NewRecNo

   DisableField_1017()

   IF New == .T.
      AMENU->(dbAppend())
      New := .F.
   ELSE
      AMENU->(dbGoto ( Win_1.Browse_1.Value ) )
   ENDIF

   NewRecNo := AMENU->( RecNo() )

   AMENU->LEVEL1     := Win_1.mLEVEL1.Value
   AMENU->LEVEL2     := Win_1.mLEVEL2.Value
   AMENU->ITEM       := Win_1.mITEM.Value
   AMENU->M_ICON     := Win_1.mM_ICON.Value
   AMENU->M_BUTTON   := Win_1.mM_BUTTON.Value
   AMENU->M_PROGRAM  := Win_1.mM_PROGRAM.Value

   Win_1.Browse_1.Refresh
   IF New == .T.
      Win_1.Browse_1.Value := NewRecNo 
   ENDIF

   UNLOCK
   dbCommitall()

   Win_1.StatusBar.Item(1) := "Save Record" 

RETURN
*:---------------------------------------------*
PROCEDURE NewRecord_1017

   Win_1.StatusBar.Item(1) := "Editing" 

   SET ORDER TO 1
   dbGoBottom()

   Win_1.mLEVEL1.Value       := 0
   Win_1.mLEVEL2.Value       := 0
   Win_1.mITEM.Value         := space(30)
   Win_1.mM_ICON.Value       := space(10)
   Win_1.mM_BUTTON.Value     := space(1)
   Win_1.mM_PROGRAM.Value    := space(50)

   EnableField_1017()

   Win_1.mLEVEL2.SetFocus

RETURN
*:---------------------------------------------*
PROCEDURE DeleteRecord_1017

   IF MsgYesNo ( "Are you sure do you want delete record?" )
      IF AMENU->(FLock())
         DELETE
         Win_1.Browse_1.Refresh
         UNLOCK
      ENDIF
   ENDIF

RETURN
*:---------------------------------------------*
PROCEDURE Find_1017

   Win_1.StatusBar.Item(1) := "Query" 

   Win_1.mLEVEL1.Value       := 0
   Win_1.mLEVEL2.Value       := 0
   Win_1.mITEM.Value         := space(30)
   Win_1.mM_ICON.Value       := space(10)
   Win_1.mM_BUTTON.Value     := space(1)
   Win_1.mM_PROGRAM.Value    := space(50)

   EnableField_1017()
   Win_1.Save_1017.Enabled  := .F.
   Win_1.Query_1017.Enabled := .T.
   Win_1.Control_1.SetFocus

RETURN
*:---------------------------------------------*
PROCEDURE PrintData_1017

   Local RecRec 

   RecRec := AMENU->( RecNo())
   dbGoTop()
   DO REPORT ;
      TITLE "AMENU" ;
      HEADERS { "","","","","","" }, { "LEVEL1","LEVEL2","ITEM","M_ICON","M_BUTTON","M_PROGRAM" } ;
      FIELDS { "LEVEL1","LEVEL2","ITEM","M_ICON","M_BUTTON","M_PROGRAM" } ;
      WIDTHS { 7,7,31,11,9,51 } ;
      TOTALS { .F.,.F.,.F.,.F.,.F.,.F. } ;
      WORKAREA AMENU ;
      LPP 50 ;
      CPL 80 ;
      LMARGIN 5 ;
      PREVIEW
   AMENU->(dbGoTo(RecRec))

RETURN
*:---------------------------------------------*
PROCEDURE PaintDisplay_1017

   @  400,5 FRAME Frame_1 WIDTH 760 HEIGHT 150

   @ 430, 20 LABEL Label_1 VALUE "L1"
   @ 430, 60 LABEL Label_2 VALUE "L2"
   @ 430, 100 LABEL Label_3 VALUE "ITEM"
   @ 430, 420 LABEL Label_5 VALUE "ICON"
   @ 480, 20 LABEL Label_6 VALUE "BUTTON"
   @ 480, 80 LABEL Label_7 VALUE "PROGRAM"

   @ 450, 20 TEXTBOX  mLEVEL1      WIDTH 30 NUMERIC INPUTMASK "99"
   @ 450, 60 TEXTBOX  mLEVEL2      WIDTH 30 NUMERIC INPUTMASK "99"
   @ 450, 100 TEXTBOX  mITEM        WIDTH 310 INPUTMASK "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
   @ 450, 420 TEXTBOX  mM_ICON      WIDTH 110 INPUTMASK "!!!!!!!!!!"
   @ 500, 20 TEXTBOX  mM_BUTTON    WIDTH 20 INPUTMASK "!"
   @ 500, 80 TEXTBOX  mM_PROGRAM   WIDTH 510

RETURN
*:---------------------------------------------*
PROCEDURE Head1_1017

   SELECT AMENU
   SET ORDER TO 1
   dbGotop()
   Win_1.Browse_1.Value := RecNo()
   Win_1.Browse_1.Refresh
   LoadData_1017()

RETURN
*:---------------------------------------------*
PROCEDURE Head2_1017

   SELECT AMENU
   SET ORDER TO 2
   dbGotop()
   Win_1.Browse_1.Value := RecNo()
   Win_1.Browse_1.Refresh
   LoadData_1017()

RETURN
*:---------------------------------------------*
PROCEDURE QueryRecord_1017

   PreQuery_1017()

   SET FILTER TO &_qry_exp
   dbGotop()

   IF ! EMPTY( _qry_exp )
      COUNT TO found_rec FOR &_qry_exp
      dbGotop()

      IF found_rec = 0
         Win_1.Statusbar.Item(1) := "Not found!"
      ELSE
         Win_1.Statusbar.Item(1) := "Found " + ALLTRIM(STR(found_rec)) + " record(s)!"
      ENDIF
   ENDIF

   DisableField_1017()

   Win_1.Browse_1.Refresh
   Win_1.Browse_1.Enabled   := .T.

RETURN
*:---------------------------------------------*
PROCEDURE PreQuery_1017

_qry_exp := ""
_ima_filter := .F.

IF ! EMPTY ( Win_1.mLEVEL1.Value )     // LEVEL1
   IF _ima_filter
      _qry_exp = _qry_exp + " .AND. "
   ENDIF
      _qry_exp = _qry_exp + "LEVEL1 = " + STR( Win_1.mLEVEL1.Value )
      _ima_filter := .T.
ENDIF

IF ! EMPTY ( Win_1.mLEVEL2.Value )     // LEVEL2
   IF _ima_filter
      _qry_exp = _qry_exp + " .AND. "
   ENDIF
      _qry_exp = _qry_exp + "LEVEL2 = " + STR( Win_1.mLEVEL2.Value )
      _ima_filter := .T.
ENDIF

IF ! EMPTY ( Win_1.mITEM.Value )     // ITEM
   IF _ima_filter
      _qry_exp = _qry_exp + " .AND. "
   ENDIF
      _qry_exp = _qry_exp + "ITEM = " + chr(34) + Win_1.mITEM.Value + chr(34)
      _ima_filter := .T.
ENDIF

IF ! EMPTY ( Win_1.mM_ICON.Value )     // M_ICON
   IF _ima_filter
      _qry_exp = _qry_exp + " .AND. "
   ENDIF
      _qry_exp = _qry_exp + "M_ICON = " + chr(34) + Win_1.mM_ICON.Value + chr(34)
      _ima_filter := .T.
ENDIF

IF ! EMPTY ( Win_1.mM_BUTTON.Value )     // M_BUTTON
   IF _ima_filter
      _qry_exp = _qry_exp + " .AND. "
   ENDIF
      _qry_exp = _qry_exp + "M_BUTTON = " + chr(34) + Win_1.mM_BUTTON.Value + chr(34)
      _ima_filter := .T.
ENDIF

IF ! EMPTY ( Win_1.mM_PROGRAM.Value )     // M_PROGRAM
   IF _ima_filter
      _qry_exp = _qry_exp + " .AND. "
   ENDIF
      _qry_exp = _qry_exp + "M_PROGRAM = " + chr(34) + Win_1.mM_PROGRAM.Value + chr(34)
      _ima_filter := .T.
ENDIF

RETURN
*:************************************************
FUNCTION OpenFileName_1017()

   Win_1.mM_PROGRAM.Value := Getfile ( { {'All Files','*.*'} } , 'Open File' , 'c:\' , .f. , .t. )
   AMENU->M_PROGRAM  := Win_1.mM_PROGRAM.Value
   
RETURN .t.
